(function(){

  $.fakeTable = {
    prefix: 'f_',
    errors: true,
    table_parts: 'thead, tbody, tr, th, td',
    include_sub_tables: false,
    element: 'div'
  }

  $.fn.fakeTable = function(opts){
    var opts = opts || {}
    opts = $.extend({}, $.fakeTable, opts);

    if (opts['include_sub_tables']) {
      opts['table_parts'] += ', table'
    }

    return this.each(function() {

      if (!$(this).is('table')) {
        if (opts['errors']) console.error('Not a table');
        return;
      };

      $(this).find('[data-f-dropdown]').addClass('f_dropdown_closed').changeTag('div', function(elem){

        $(this).addClass('f_dropdown_container');

        $(this).children('td').changeTag('div', function(){
          $(this).addClass(opts['prefix'] + 'dropdown_column');
        });


        $(this).wrapInner('<div class="f_dropdown_container_inner">')
      });



      $(this).find(opts['table_parts']).changeTag(opts['element'], function(oldElem){
        var oldTagName = oldElem.tagName.toLowerCase();
        $(this).addClass(opts['prefix'] + oldTagName);
      });

      $('[data-f-dropdown-trigger]').on('click', function(){
        var dropdownName = $(this).data('f-dropdown-trigger');
        $('[data-f-dropdown=' + dropdownName + ']').toggleClass('f_dropdown_closed')
      });


      x = $(this).changeTag(opts['element'], function(oldElem){
        var oldTagName = oldElem.tagName.toLowerCase();
        $(this).addClass(opts['prefix'] + oldTagName);
        
        $(this).on('fake_table_update', tableUpdate)

      }).trigger('fake_table_update');

      $(window).on('resize', function(){
        $(x).trigger('fake_table_update');
      });

    });


    function tableUpdate() {
      console.log("HI")
      $(this).find('.f_dropdown_container_inner').width($(this).width())

      //set dropdown container height to match the tallest child
      var tallestChild = 0;
      $(this).find('.f_dropdown_column').each(function(){
        console.log(this, $(this).height());
        tallestChild = (tallestChild > $(this).height())? tallestChild : $(this).height();
      });

      //set dropdown widths to match the table
      $(this).find('.f_dropdown_container, .f_dropdown_container_inner').height(tallestChild);

    }

    

  }


})(jQuery);
