# frozen_string_literal: true
module C
  class Front::Devise::SessionsController < Devise::SessionsController
    layout 'c/main_application'
    after_action :after_login, only: :create

    def after_login
      return unless session[:cart_id].present?
      begin
        customer = current_front_customer_account.customer
        cart = C::Cart.find(session[:cart_id])
        cart.update(customer_id: customer.id)
        cart.order.update(customer: customer) if cart.order.present?
      rescue ActiveRecord::RecordNotFound
        # Do nothing, as there is nothing to set
      end
    end

    def after_sign_in_path_for(resource)
      request[:checkout] ? new_checkout_path : super
    end

    def after_sign_out_path_for(_resource_or_scope)
      '/'
    end
  end
end
