# frozen_string_literal: true
require_dependency 'c/application_controller'

module C
  class FrontEnd::BlogsController < MainApplicationController
    include BlogsHelper

    def index
      get_page C::Page, 'blogs'
      @blogs = C::Blog.order(created_at: 'DESC')
      archive_blogs
    end

    def show
      get_page C::Blog
      @blog = @page
      redirect_to root_url unless @blog.published || user_signed_in?
      force_clean_url @blog
    end
  end
end
