# frozen_string_literal: true
require_dependency 'c/application_controller'

module C
  class FrontEnd::EnquiriesController < MainApplicationController
    def new
      get_page C::Page, 'contact-us'
      @enquiry = C::Enquiry.new
    end

    def create
      get_page C::Page, 'contact-us'
      @enquiry = C::Enquiry.new(enquiry_params)
      if @enquiry.save
        C::EnquiriesMailer.new_enquiry(@enquiry).deliver_now
        redirect_to thanks_front_end_enquiries_path
      else
        render :new
      end
    end

    def thanks
      @enquiry = C::Enquiry.new
    end

    private

    def enquiry_params
      params.require(:enquiry).permit(:name, :email, :body)
    end
  end
end
