# frozen_string_literal: true
require_dependency 'c/application_controller'

module C
  class FrontEnd::ProjectsController < MainApplicationController

    def index
      get_page C::Page, 'projects'
      @projects = C::Project.order(created_at: 'DESC')
    end

    def show
      get_page C::Project
      @project = @page
      redirect_to root_url unless @project.published || user_signed_in?
      force_clean_url @project
    end
  end
end
