# frozen_string_literal: true
module C
  module LinkToHelper
    def link_to_delete(text, resource, opts={})
      nested = [opts.delete(:nested) { [] }].flatten

      opts[:data] ||= {}

      url = opts.delete(:url) { nil }
      redirection = opts.delete(:redirection) { nil }
      opts[:data].merge!(delete_link: url || url_for([*nested, resource]),
                         after_delete_redirection: redirection)
      link_to text, [:confirm_destroy, *nested, resource], opts
    end

    def link_to_add_fields(name, f, assoc, opts={})
      new_object = f.object.send(assoc).build
      id = new_object.object_id
      fields = f.fields_for(assoc, new_object, child_index: id) do |builder|
        render assoc.to_s.singularize + '_fields', f: builder
      end
      link_to name, '#', data: { fields: fields.gsub('\n', ''), fields_id: id }.merge(opts)
    end
  end
end
