# frozen_string_literal: true
module C
  module NavigationHelper
    def ensure_navigation
      @navigation ||= [{ title: 'Home', url: '/' }]
    end

    def navigation_add(title, url)
      ensure_navigation << { title: title, url: url }
    end

    def render_navigation(partial = nil)
      render partial: partial || 'c/admin/bread_crumbs', locals: { nav: ensure_navigation }
    rescue
      nil
    end

    def parent_navigation_add(nav)
      @tree_navigation ||= []
      @tree_navigation << { title: nav.name, url: nav }
      if nav.parent
        parent_navigation_add nav.parent
      else
        @tree_navigation.reverse.map { |node| ensure_navigation << node }
      end
    end
  end
end
