# frozen_string_literal: true
module C
  module PagesHelper
    def get_page(model, url=params[:id])
      @page = if !url.present? || (url =~ /[^0-9]/)
                model.get_from_url(url)
              else
                # This is accommodating a use-case that *will* result in problems, given enough products
                model.find_by(id: url) || model.get_from_url(url)
              end
      begin
        @page_info = @page.page_info
      rescue NoMethodError
        raise ActiveRecord::RecordNotFound
      end
      if @page.respond_to?('layout') && !@page.layout.blank? && @page.layout != 'show'
        @render = @page.layout
      else
        @page
      end
    end

    def force_clean_url(object)
      redirect_to [:front_end, object] if object.url_alias && params[:id] != object.url_alias
    end
  end
end
