# frozen_string_literal: true
module C
  class Document < ApplicationRecord
    mount_uploader :document, C::FileUploader
    validates :document, presence: true
    belongs_to :documentable, polymorphic: true

    INDEX_TABLE = {
      "Name": { call: 'name' },
      "File": { call: 'document.url' },
      "Created": { call: 'created_at' },
      "Delete": { link: { name: { text: 'Delete' }, options: '[object]', method: :delete, data: { confirm: 'Are you sure?' } } }
    }.freeze

    # TODO: Add edit to this, name should link to edit page
  end
end
