# frozen_string_literal: true
module C
  class Location < ApplicationRecord
    include SitePage
    include Imageable
    include Previewable
    include Orderable

    validates :name, presence: true

    INDEX_TABLE = {
      "Name": { link: { name: { call: 'name' }, options: '[:edit, object]' }, sort: 'name' },
      "Published": { call: 'published', sort: 'published' },
      "Created": { call: 'created_at', sort: 'published' },
      "Edit": { link: { name: { text: 'edit' }, options: '[:edit, object]' } }
    }.freeze
  end
end
