# frozen_string_literal: true
module C
  class Project < ApplicationRecord
    include SitePage
    include Imageable
    include Orderable
    include Previewable
    include Authorable

    validates :name, presence: true

    INDEX_TABLE = {
      'Name': { link: { name: { call: 'name' }, options: '[:edit, object]' }, sort: 'name' },
      'Author': { call: 'author', sort: 'author' },
      'Published': { call: 'published', sort: 'published' },
      'Created': { call: 'created_at', sort: 'published' },
      'Edit': { link: { name: { text: 'edit' }, options: '[:edit, object]' } }
    }.freeze
  end
end
