# frozen_string_literal: true
module C
  module Previewable
    extend ActiveSupport::Concern

    included do
      def preview_body
        if !self.class.column_names.include?('preview_body') || super.blank?
          if body.present?
            ActionController::Base.helpers.strip_tags(body.gsub(%r{<h(\d)>.*?<\/h(\1)>}, '')).truncate(150, strip_tags: true)
          else
            ''
          end
        else
          super
        end
      end
    end
  end
end
