# encoding: utf-8
# frozen_string_literal: true
module C
  class ImageUploader < CarrierWave::Uploader::Base
    include CarrierWave::MiniMagick

    def store_dir
      "uploads/#{model.class.to_s.underscore}/#{mounted_as}/#{model.id}"
    end

    version :thumbnail do
      process resize_and_pad: [150, 150]
    end

    version :preview do
      process resize_to_fit: [100, 100]
    end

    version :cropped_square do
      process resize_to_fill: [300, 300]
    end

    version :square do
      process resize_to_fit: [300, 300]
    end

    version :big_sq do
      process resize_and_pad: [600, 400]
    end

    version :large do
      process resize_to_fill: [1000, 600]
    end

    version :cropped_rect do
      process :resize_to_fill => [250, 100]
    end
  end
end
