# frozen_string_literal: true
require 'rubygems'
require 'fog/aws'
Gem.loaded_specs['cd2_catton_cms'].dependencies.each do |d|
  require d.name unless ['fog-aws', 'google_currency'].include?(d.name)
end

require 'c/engine'

module C
  class << self
    mattr_accessor :store_name
    self.store_name = 'Name'

    mattr_accessor :domain_name
    self.domain_name = 'example.com'

    mattr_accessor :email, :enquiries_email, :errors_email, :order_notification_email
    self.email                    = 'web@example.org'
    self.enquiries_email          = 'web@example.org'
    self.errors_email             = 'web@example.org'
    self.order_notification_email = 'recipient@example.com'

    mattr_accessor :external_logo_url
    self.external_logo_url = ''

    mattr_accessor :primary_color
    self.primary_color = '#5C5C5C'

    mattr_accessor :admin_mount
    self.admin_mount = 'admin'

    mattr_accessor :account_mount
    self.account_mount = 'account'

    mattr_accessor :commerce
    self.commerce = true

    mattr_accessor :content_sections
    self.content_sections = [:pages, :services, :projects, :locations, :blogs, :testimonials, :slideshows, :team]

    # specify channel name to display first channel image on index tables
    mattr_accessor :display_thumbnail
    self.display_thumbnail = nil
  end

  # this function maps the vars from your app into your engine
  def self.setup(*)
    yield self
  end
end
